<script setup lang="ts">
import { useDate } from 'vuetify'

// import { userUserStores } from '@/views/user/stores/user'

import type { Receipt } from '@/views/receipt/types/receipt'
import type { ReceiptItem } from '@/views/receipt/types/receiptItem'
import { computed } from 'vue'
import { useAuthStore } from '@/stores/auth'
import { usePosStore } from '../stores/pos'
const auth = useAuthStore()

const posStore = usePosStore()
// const userStore = userUserStores()
// const = use)
// const dialog = inject<Ref<boolean>>('receiptDialog')

const props = defineProps<{
  modelValue: boolean
  receipt: Receipt
  receiptItems?: ReceiptItem[]
}>()
const emit = defineEmits<{
  'update:modelValue': [boolean]
  agree: []
}>()
const value = computed({
  get() {
    return props.modelValue
  },
  set(value) {
    emit('update:modelValue', value)
  }
})
</script>

<template>
  <v-dialog v-model:model-value="value" persistent width="500">
    <v-card>
      <v-card-title class="text-h5 text-center mt-5"> Confirm Payment </v-card-title>
      <v-card-text>
        <v-sheet border="md" class="pa-6 text-white mx-auto" max-width="auto" style="color: white">
          <v-container>
            <v-row no-gutters style="color: white">
              <v-col></v-col>
              <v-col cols="7">
                <v-img src="src\assets\MainLogo.png" width="50"></v-img>
              </v-col>
              <v-col cols="12">
                <div style="text-align: center; color: white">
                  D-Coffee <br />
                  <div v-if="receipt.branch">
                    {{ receipt.branch.name }}
                  </div>
                  <div v-else>
                    คณะสหเวชศาสตร์ มหาวิทยาลัยบูรพา <br />
                    ประเทศไทย จ.ชลบุรี 20130<br />
                    โทร 095 332 5290
                  </div>
                </div>
                <br />
              </v-col>
              <!-- <v-col cols="6">
                <p>TAX ID : {{ receipt.id }}</p>
              </v-col> -->
              <!-- <v-col cols="4">
                <p>Queue : {{ queue }}</p>
              </v-col> -->
              <v-col cols="6">
                <p>DATE : {{ useDate().format(receipt.createdDateTime, 'shortDate') }}</p>
              </v-col>
              <v-col cols="6">
                <p>
                  TIME :
                  {{
                    receipt.createdDateTime.toLocaleTimeString('th-TH', {
                      hour12: false
                    }) ?? ''
                  }}
                </p>
              </v-col>
              <v-col cols="12">
                <p>ผู้ออกใบเสร็จ : {{ auth.getCurrentUser()?.fullName }}</p>
              </v-col>
              <v-divider class="mt-2"></v-divider>
              <v-col>
                <v-table class="border-1">
                  <thead>
                    <tr>
                      <th>รายการ</th>
                      <th>จำนวน</th>
                      <th>ราคา (บาท)</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="item in receipt.receiptItems" :key="item.id">
                      <td>{{ item.name }}</td>
                      <td>{{ item.unit }}</td>
                      <td>{{ item.price * item.unit }}</td>
                    </tr>
                  </tbody>
                  <tfoot>
                    <tr>
                      <td>รวม {{ receipt.totalUnit }} รายการ</td>
                      <td></td>
                      <td>{{ receipt.totalBefore }} บาท</td>
                    </tr>
                  </tfoot>
                </v-table>
              </v-col>
              <v-divider class="mb-2"></v-divider>
              <v-col cols="12">
                <p v-if="receipt.promotion">โปรโมชัน : {{ receipt.promotion?.name }}</p>
              </v-col>
              <v-col cols="12">
                <p v-if="receipt.promotion">ส่วนลด : {{ receipt.discount }} บาท</p>
              </v-col>
              <v-col cols="12">
                <p v-if="receipt.usePoint">ใช้ point ลด : {{ receipt.usePoint }} บาท</p>
              </v-col>
              <v-col cols="12">
                <p>จำนวนเงินรวมทั้งสิ้น : {{ receipt?.netPrice }} บาท</p>
              </v-col>
              <v-divider class="my-2"></v-divider>
              <v-col cols="12">
                <p>วิธีการชำระเงิน : {{ receipt.paymentType }}</p>
              </v-col>
              <v-col cols="12">
                <p>จำนวนเงิน : {{ receipt.totalBefore }} บาท</p>
              </v-col>
              <v-col cols="12">
                <p>เงินทอน : {{ receipt.change }} บาท</p>
              </v-col>
              <v-divider class="my-2"></v-divider>
              <v-col>
                <p>สมาชิก : {{ receipt?.customer?.name }}</p>
                <p>คุณได้รับ Point : {{ receipt?.givePoint }}</p>
                <p>Point สะสม : {{ receipt?.totalPoint }}</p>
              </v-col>
              <v-divider class="my-2"></v-divider>
              <v-col class="center">
                <p style="text-align: center">
                  Thank you for shopping with us. <v-icon icon="mdi-heart"></v-icon>
                </p>
              </v-col>
            </v-row>
          </v-container>
        </v-sheet>
      </v-card-text>
      <v-card-actions>
        <v-btn
          color="orange-darken-1"
          variant="text"
          @click="
            () => {
              value = false
              
            }
          "
        >
          <p class="font-weight-bold">Print</p>
        </v-btn>
        <v-spacer></v-spacer>

        <v-btn
          color="red-darken-1"
          variant="text"
          @click="
            () => {
              //   addReceiptItem()
              value = false
              console.log(receipt)
              console.log(receiptItems)
              posStore.resetTempReceipt()
            }
          "
        >
          <p class="font-weight-bold">close</p>
        </v-btn>
        <v-btn
          color="green-darken-1"
          variant="text"
          @click="
            () => {
              value = false
              posStore.saveReceipt()
              console.log(receipt)
              console.log(receiptItems)
              // emit('agree'), (receiptDialog = false), clear()
            }
          "
        >
          <p class="font-weight-bold">save</p>
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
